#ifndef __popup_h
#define __popup_h

#include <GL/gl.h>
    
#ifdef UNIX
#include <GL/glx.h>
#endif				/* 
 */
#ifdef WIN32
#include <windows.h>
#endif				/* 
 */
    
typedef struct {
	

	    // GLubyte will work for images up to 32-bits.
	GLubyte * imageData;
	

			// Stores the color depth of the image in bits
	    // per pixel.
	GLuint bpp;
	
GLuint channels;
	
GLuint width;
	
GLuint height;
	
GLuint truewidth;
	
GLuint trueheight;
	
float aspectratio;
	
GLuint texID;		// For texture objects; more later.
} Texture;


struct PopupWindow {
	
int xPos;
	
int yPos;
	
int width;
	
int height;
	
int imageheight;
	
Texture * tex;
	
char *name;
	
long colour;
	
char *message;
	
long colour2;
	
char *alerts;
	
#ifdef UNIX
	 Window win;
	
XEvent event;
	
#endif				/* 
 */
#ifdef WIN32
	 HWND win;
	
HDC context;
	
HGLRC rendcontext;
	
#endif				/* 
 */
	float frames;
	
int drawcount;

};


typedef struct PopupWindow PopupWindow;


#ifndef max
#define max(a, b)  (((a) > (b)) ? (a) : (b))
#endif				/* 
 */
#ifndef min
#define min(a, b)  (((a) > (b)) ? (b) : (a))
#endif				/* 
 */

int initGL();

int initSound();

int LoadFont();

void renderTag(struct PopupWindow *window);

int LoadIcons();

int initWinIcons();

int init();

int soundeffect(char c);

void createWindow(struct PopupWindow *pw, Texture * tex, char *name, long colour, 
char *message, long colour2,
		     char *alerts, int limitimage);

void destroyWindow(struct PopupWindow *pw);

long msecs(void);

int initTexture(Texture * tex);

int initWinFont();

int checkGLErrors(char *funcname);

int ignoredoor(int doorid);

#endif				/* 
 */
